import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy extends GifActor
{
    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Enemy() 
    {
        if (Greenfoot.getRandomNumber(2)==1)
        {
            turn(90);
        }
    }
    
    public void act()
    {
        turnAtEdge();
        randomTurn();
        move(5);
        lookForTheMagicMan();
        die();
        if (canSee(Bullet.class))
        {
            getWorld().removeObject(this);
        }
    }

    /**
     * Check whether we are at the edge of the world. If we are, turn a bit.
     * If not, do nothing.
     */
    public void turnAtEdge()
    {
        if ( atWorldEdge() ) 
        {
            turn(17);
        }
    }

    /**
     * Randomly decide to turn from the current direction, or not. If we turn
     * turn a bit left or right by a random degree.
     */
    public void randomTurn()
    {
        if (Greenfoot.getRandomNumber(100) > 90) {
            turn(Greenfoot.getRandomNumber(90)-45);
        }
    }

    /**
     * Try to pinch a crab. That is: check whether we have stumbled upon a crab.
     * If we have, remove the crab from the game, and stop the program running.
     */
    public void lookForTheMagicMan()
    {
        if ( canSee(TheMagicMan.class) ) 
        {
            eat(TheMagicMan.class);
            
            Greenfoot.stop();
        }
    }
    public void die()
    {
        if (Greenfoot.mouseClicked(this))
        {
            getWorld().removeObject(this);
        }
    }
}
   

